plugins["colors"] = {
  version: "v1.0.6",
  lastChange: "Nov 23rd, 2008",
  displayName: "Colors",
  directory: currentDirectory,
  icon: currentDirectory + "\\colors.ico",
  aliasstr: "colors",
  // XXX: the following 4 lines should not be in this script
  //regexfiltergroup: 1, 
  //regexsearchfilter: "$$1", 
  //regexstr: "^" + this.aliasstr + " ?(.*)", 
  //regexobj: /^colors ?(.*)/, // to get one-time compilation of the regex
  _colorsData: {"red": "#FF0000", "green": "#00FF00", "blue": "#0000FF",
                "grey": "#808080", "yellow": "#FFFF00", "orange": "#FFA500", 
                "pink": "#FFC0CB", "purple": "#A020F0", "cyan": "#00FFFF",
                "brown": "#A52A2A", "black": "#000000", "white": "#FFFFFF"},
  search: function(querykey, explicit, queryraw, querynokeyword, 
                   modifier, triggermethod) { 
    if (!explicit) return;
    for (var color in this._colorsData) {
      FARR.emitResult(querykey, color, "colors", this.icon, CLIP, 
		      MATCH_AGAINST_SEARCH, 10000);
		      //MATCH_AGAINST_SEARCH_W_PATS, 10000);
                      //MATCH_AGAINST_SEARCH_W_PATS, 10000, "colors"); // XXX
    } 
  }, 
  trigger: function(path, title, groupname, pluginid, thispluginid, 
                    score, entrytype, args) {
    //if (groupname != "colors") { return; } // XXX
    if (!(title in this._colorsData)) { return; }
    pasteClipboardToLastActiveWindow(this._colorsData[title]);
    return HANDLED|CLOSE;
  }, 
  showSettings: function() {
    FARR.debug("showSettings");
    //FARR.exec(this.directory+"\\colorsSettings.ahk");
  }
}
